Bug 442725 - LTC43264-NumLock broken on some keyboards
LTC43264-NumLock broken on some keyboards
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: xkeyboard-config (Show other bugs)
5.0
All Linux
low Severity low
: rc
: ---
Assigned To: Peter Hutterer
desktop-bugs@redhat.com
: OtherQA
Depends On:
Blocks: 391501
  Show dependency treegraph
 
Reported: 2008-04-16 09:46 EDT by Alan Matsuoka
Modified: 2011-01-24 17:54 EST (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-09-02 08:13:41 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
xkb patch (2.45 KB, patch)
2008-04-16 09:47 EDT, Alan Matsuoka
no flags Details | Diff
xmodmap output (7.36 KB, application/octet-stream)
2008-04-16 09:50 EDT, Alan Matsuoka
no flags Details

  None (edit)
Description Alan Matsuoka 2008-04-16 09:46:59 EDT
LTC Owner is: aoolatun@us.ibm.com
LTC Originator is: harrigan@us.ibm.com

---Problem Description---
Keyboards with a single key that shares ScrollLock and NumLock do not function
properly in GUI (both GNOME and KDE).  The key mapping of Shift + Scroll_Lock
should equal Num_Lock, but does not.  It appears that Shift + Num_Lock has a
special meaning, however, since Shift is needed to get Num_Lock (shared
Scroll_Lock/Num_Lock key) any time you attempt to use Num_Lock, you get the
special meaning of Shift + Num_Lock, not plain old Num_Lock.  This can be viewed
in xev window.  Using xmodmap -e "keycode 77 = Num_Lock Num_Lock" appears to
correct this problem by over-riding the special meaning of Shift + Num_Lock.


---Additional Hardware Info---
Just a USB keyboard that has a shared Scroll_Lock/Num_Lock key.  We are using
IBM P/N 40K9400 and 40K5386 to repro this problem locally.  They keyboard may
also need to have the number keypad shared with the letters (j,k,l,etc.)
although we don't have any other keyboards to verify this with.

---uname output---
RHEL 4 and RHEL 5 all versions

Machine Type = HS21 XM 7995

---Steps to Reproduce---
Install OS, boot to your favorite X Desktop Environment, use a keyboard with
shared Scroll_Lock/Num_Lock key, and attempt to use the Num_Lock functionality.  

---XFree86/X.org Component Data---
/etc/selinux/config output: N/A

Userspace tool common name: Various X Desktop Environments

"rpm -qa | grep -i selinux" output: N/A

The userspace tool has the following bit modes: Both

Adapter and monitor type: ATI RN50 (es1000)

Userspace rpm: Both GNOME and KDE

*Additional Instructions for david harrigan/harrigan@us.ibm.com:
-Attach ltrace and strace of userspace application.
-Attach:
 graphics config file (RHEL4 and RHEL5 = /etc/X11/xorg.conf, RHEL3 =
/etc/X11/XF86Config)
 graphics log file (RHEL4 and RHEL5 = /var/log/Xorg.0.log, RHEL3 =
/var/log/XFree86.0.log)
 lspci-v output  
 /var/log/messages

-------------------------------------------------------------------------
------------------------
While this is a duplicate defect , the fix/workaround given does not work for
Japanese keyboards.  I assume it also doesn't work for Chinese keyboards and any
other keyboard where the latin letters are also assigned to language specific
symbols.

The fix/workaround listed eliminates the latin characters from the keyboard
map and uses only Japanese (or other) symbols.  The following  attachment is the
result of
the current recommended workaround.

A sample fix of this problem for RHEL 5.2.

The following instruction assumes that the patch file is at /tmp/xkb.patch
1. Make a backup for xkb files
  # cd /usr/share/X11
  # cp -a xkb xkb.orig

2. Apply the patch file.
  # patch -p0 < /tmp/xkb.patch

3. Edit /etc/X11/xorg.conf file

  Section "InputDevice"
Identifier  "Keyboard0"
Driver    "kbd"
Option    "XkbLayout" "jp"
  # Option    "XkbModel" "jp106"
Option    "XkbModel" "ibm_space_saver"
Option    "XkbRules" "xorg"
  EndSection

4. Shutdown and reboot the system
  # shutdown -r now

We tested the patch and it works properly. Please let us know if this would be
added to the next RHEL release.


The files that are patched come from a noarch rpm that is common to both 32
and 64 bit.  This failure occures in 4.5, 4.6, 5.0, 5.1, and 5.2 (as well as
earlier I am guessing).  This issue occurs on any keyboard where Num Lock and
Scroll Lock share the same key.  Google results show this is occuring on
IBM/Lenovo thinkpads as well (NumLock/ScrlLck share same key).  This is NOT a
regression, this problem has always existed.  (shows how often NumLock is used)

This has been tested on multiple systems (Intel Blades, AMD servers, Intel
Servers, NUMA systems, etc), in multiple countries, in multiple languages.  
This problem is seen (via google search) by multiple people at multiple
companies on varied hardware, all using IBM keyboards where ScrLk and NMLK
share the same key.

This is nothing more and nothing less than the xkeyboard-config not
recongizing IBM keyboards that use a single key for NumLock and Scroll Lock,
therefor assuming that [SHIFT]+[SCRLK] should translate to something other
than NumLock.
Comment 1 Alan Matsuoka 2008-04-16 09:47:00 EDT
Created attachment 302602 [details]
xkb patch
Comment 2 Alan Matsuoka 2008-04-16 09:50:23 EDT
Created attachment 302603 [details]
xmodmap output
Comment 3 RHEL Product and Program Management 2008-06-02 16:06:01 EDT
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux maintenance release.  Product Management has requested
further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed
products.  This request is not yet committed for inclusion in an Update
release.
Comment 5 RHEL Product and Program Management 2009-03-11 10:58:38 EDT
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux maintenance release.  Product Management has requested
further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed
products.  This request is not yet committed for inclusion in an Update
release.
Comment 7 Peter Hutterer 2009-05-04 19:10:45 EDT
MODIFIED
xkeyboard-config-0.8-8 is available in brew.
Comment 9 Chris Ward 2009-06-14 19:15:00 EDT
~~ Attention Partners RHEL 5.4 Partner Alpha Released! ~~

RHEL 5.4 Partner Alpha has been released on partners.redhat.com. There should
be a fix present that addresses this particular request. Please test and report back your results here, at your earliest convenience. Our Public Beta release is just around the corner!

If you encounter any issues, please set the bug back to the ASSIGNED state and
describe the issues you encountered. If you have verified the request functions as expected, please set your Partner ID in the Partner field above to indicate successful test results. Do not flip the bug status to VERIFIED. Further questions can be directed to your Red Hat Partner Manager. Thanks!
Comment 10 Chris Ward 2009-07-03 14:02:15 EDT
~~ Attention - RHEL 5.4 Beta Released! ~~

RHEL 5.4 Beta has been released! There should be a fix present in the Beta release that addresses this particular request. Please test and report back results here, at your earliest convenience. RHEL 5.4 General Availability release is just around the corner!

If you encounter any issues while testing Beta, please describe the issues you have encountered and set the bug into NEED_INFO. If you encounter new issues, please clone this bug to open a new issue and request it be reviewed for inclusion in RHEL 5.4 or a later update, if it is not of urgent severity.

Please do not flip the bug status to VERIFIED. Only post your verification results, and if available, update Verified field with the appropriate value.

Questions can be posted to this bug or your customer or partner representative.
Comment 11 Chris Ward 2009-07-10 15:04:32 EDT
~~ Attention Partners - RHEL 5.4 Snapshot 1 Released! ~~

RHEL 5.4 Snapshot 1 has been released on partners.redhat.com. If you have already reported your test results, you can safely ignore this request. Otherwise, please notice that there should be a fix available now that addresses this particular request. Please test and report back your results here, at your earliest convenience. The RHEL 5.4 exception freeze is quickly approaching.

If you encounter any issues while testing Beta, please describe the issues you have encountered and set the bug into NEED_INFO. If you encounter new issues, please clone this bug to open a new issue and request it be reviewed for inclusion in RHEL 5.4 or a later update, if it is not of urgent severity.

Do not flip the bug status to VERIFIED. Instead, please set your Partner ID in the Verified field above if you have successfully verified the resolution of this issue. 

Further questions can be directed to your Red Hat Partner Manager or other appropriate customer representative.
Comment 14 errata-xmlrpc 2009-09-02 08:13:41 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHEA-2009-1369.html

Note You need to log in before you can comment on or make changes to this bug.